#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int rhs, const mxArray *prhs[]){
	double *yTrue, *yPred;			/* True and predicted labels */
	double *AUC;					/* (Unnormalized) AUC */
	int i, j;						/* Counters for various purposes */
	int n;							/* Number of labels */
    int correct = 0;
	double agree = 0;
	
	#define Y_PRED	prhs[0]			/* Predicted labels */
	#define Y_TRUE	prhs[1]			/* True labels */
	#define AUC_OUT	plhs[0]			/* Output AUC */
	
	yPred = mxGetPr(Y_PRED);
	yTrue = mxGetPr(Y_TRUE);
	
	if(mxGetM(Y_PRED) != mxGetM(Y_TRUE))
		mexErrMsgTxt("Number of predicted labels is not same as number of true labels\n");
	
	/* How many labels do we have ? */
	n = mxGetM(Y_PRED);
	
	AUC_OUT = mxCreateDoubleMatrix(1, 1, mxREAL);
	AUC = mxGetPr(AUC_OUT);
	
	for(i = 0; i < n; i++){
		for(j = i+1; j < n; j++){
			if(yTrue[i] != yTrue[j]){
				agree =  (yTrue[i]-yTrue[j])*(yPred[i]-yPred[j]);
				if(agree > 0)
					correct++;
			}
		}
	}
	
	AUC[0] = correct;
	
	return;
}